try {
importScripts("../pjcl.js");
} catch(e) {throw new Error("could not import ../pjcl.js");}
try {
importScripts("../browserEntropy.js");
} catch(e) {throw new Error("could not import ../browserEntropy.js");}
try {
importScripts("AddStackToError.js");
} catch(e) {throw new Error("could not import AddStackToError.js");}

onmessage = function(e) { try {
	var pqLengths = e.data[0];
	var domainParameterSeed_hex = e.data[1];
	var domainParameterSeed = pjclHex2BitArray(domainParameterSeed_hex);
	var validateParams = e.data[2];
	var index = [0,0,0,0,0,0,0,1];
	if (pqLengths == "2048_256") {
		var o = pjclFFCGenPQG_2048_256(domainParameterSeed,index);
		var vPQ = pjclFFCValidatePQ_2048_256(o.p,o.q,o.domainParameterSeed,o.counter);
		var vG = pjclFFCValidateG_256(o.g,o.p,o.q,o.domainParameterSeed,index);
		postMessage([
			pjclBigInt2Hex(o.p,512),
			pjclBigInt2Hex(o.q,64),
			pjclBigInt2Hex(o.g,512),
			pjclBitArray2Hex(o.domainParameterSeed,64),
			o.counter,
			vPQ,
			vG]);
	}
	else {
		var o = pjclFFCGenPQG_3072_256(domainParameterSeed,index);
		var vPQ = pjclFFCValidatePQ_3072_256(o.p,o.q,o.domainParameterSeed,o.counter);
		var vG = pjclFFCValidateG_256(o.g,o.p,o.q,o.domainParameterSeed,index);
		postMessage([
			pjclBigInt2Hex(o.p,768),
			pjclBigInt2Hex(o.q,64),
			pjclBigInt2Hex(o.g,768),
			pjclBitArray2Hex(o.domainParameterSeed,64),
			o.counter,
			vPQ,
			vG]);
	}
	close();
} catch(e) {
	throw new Error(pjclAddStackToError(e));
}}
